#!/bin/sh

#set -x

script_name=$(basename $0)
PWD=/root/${script_name%.*}

ret_success=0
ret_fail=1
ret_fail_others=7

log_exit() 
{
    echo `date` "$script_name upgrade: ${1} exit $2" 
    exit ${2}
}

kernel_install()
{
    echo "************开始升级内核************"
    CurrentKernelVersion=$(uname -r)
    if [ ${CurrentKernelVersion} = "3.10.0-514.26.2.el7.x86_64" ]; then

        yum install ${PWD}/package/kernel*

        if [ $? -eq 0 ]; then
            echo "************内核安装成功************"
            echo "************开始grub2引导配置************"
            grub2-mkconfig -o /boot/grub2/grub.cfg
            if [ $? -eq 0 ]; then
                echo "************grub2引导配置成功************" 
            else
                log_exit "************grub2引导配置失败************" $ret_fail
            fi
        else
                log_exit "************内核安装失败************" $ret_fail
        fi
    else
        log_exit "************当前系统内核版本，不是目标升级版本************" $ret_fail_others
    
    fi
    echo "************升级内核完成,准备重启系统************"
    
    #重启机器
    sync && reboot
}

drive_replace()
{
    local flag=1
    read -p "选择替换【CSDP:1  CMN:2  OSM:3】" choose

    case "$choose" in
        1)
            echo "开始替换CSDP加密驱动"
            /etc/init.d/csdp stop

            rmmod ecard_solar2

            #备份514内核版本，加密卡驱动
            cp -rf /home/lwcsdp/driver/ecard_solar2.ko ${PWD}/backup/
            #替换1160内核版本，加密卡驱动
            cp -rf ${PWD}/package/ecard_solar2.ko /home/lwcsdp/driver/
            if [ $? -eq 0 ]; then
                chmod 777 /home/lwcsdp/driver/ecard_solar2.ko
                flag=0
                echo "替换CSDP加密驱动完成"
            fi
            ;;
        2)
            echo "开始替换CMN加密驱动"
            /etc/init.d/cmn stop

            rmmod ecard_solar2

            #备份514内核版本，加密卡驱动
            cp -rf /home/lwcmn/driver/ecard_solar2.ko ${PWD}/backup/
            #替换1160内核版本，加密卡驱动
            cp -rf ${PWD}/package/ecard_solar2.ko /home/lwcmn/driver/
            if [ $? -eq 0 ]; then
                chmod 777 /home/lwcmn/driver/ecard_solar2.ko
                flag=0
                echo "替换CMN加密驱动完成"
            fi
            ;;
        3)
            echo "开始替换OSM加密驱动"
            /etc/init.d/osm stop

            rmmod ecard_solar2
            
            #备份514内核版本，加密卡驱动
            cp -rf /home/osm/driver/ecard_solar2.ko ${PWD}/backup/
            #替换1160内核版本，加密卡驱动
            cp -rf ${PWD}/package/ecard_solar2.ko /home/osm/driver/
            if [ $? -eq 0 ]; then
                chmod 777 /home/osm/driver/ecard_solar2.ko
                flag=0
                echo  "替换OSM加密驱动完成"
            fi
            ;;
        *)
            log_exit "************无效输入************" $ret_fail_others
            ;;
    esac
    
    if [ $flag -eq 1 ]; then
        log_exit "************替换加密驱动失败************" $ret_fail
    fi
}



####################################-------Main function-------####################################
#加密驱动替换
drive_replace
#升级内核
kernel_install
