#!/bin/sh


ret_success=0
ret_fail=1
ret_fail_others=7

log_exit() 
{
    echo `date` "$script_name upgrade: ${1} exit $2" 
    exit ${2}
}

Rollback_kernel()
{
    echo "************开始回退内核************"
    CurrentKernelVersion=$(uname -r)
    if [ ${CurrentKernelVersion} = "3.10.0-1160.88.1.el7.x86_64" ]; then

        rpm -e kernel-3.10.0-1160.88.1.el7.x86_64

        if [ $? -eq 0 ]; then
            echo "************内核卸载成功************"
            echo "************开始grub2引导配置************"
            grub2-mkconfig -o /boot/grub2/grub.cfg
            if [ $? -eq 0 ]; then
                echo "************grub2引导配置成功************" 
            else
                log_exit "************grub2引导配置失败************" $ret_fail
            fi
        else
                log_exit "************内核卸载失败************" $ret_fail
        fi
    else
        log_exit "************当前系统内核版本，不是目标回退版本************" $ret_fail_others
    
    fi
    echo "************升级回退完成,准备重启系统************"
    
    #重启机器
    sync && reboot
}

Rollback_driver()
{
        local flag=1
    read -p "选择回滚【CSDP:1  CMN:2  OSM:3】" choose

    case "$choose" in
        1)
            echo "开始回滚CSDP加密驱动"
            /etc/init.d/csdp stop

            rmmod ecard_solar2

            #回滚加密卡驱动
            cp -rf ${PWD}/backup/ecard_solar2.ko /home/lwcsdp/driver/
            if [ $? -eq 0 ]; then
                chmod 777 /home/lwcsdp/driver/ecard_solar2.ko
                flag=0
                echo "回滚CSDP加密驱动完成"
            fi
            ;;
        2)
            echo "开始回滚CMN加密驱动"
            /etc/init.d/cmn stop

            rmmod ecard_solar2

            #回滚加密卡驱动
            cp -rf ${PWD}/backup/ecard_solar2.ko /home/lwcmn/driver/
            if [ $? -eq 0 ]; then
                chmod 777 /home/lwcmn/driver/ecard_solar2.ko
                flag=0
                echo "回滚CMN加密驱动完成"
            fi
            ;;
        3)
            echo "开始回滚OSM加密驱动"
            /etc/init.d/osm stop

            rmmod ecard_solar2
            
            #回滚加密卡驱动
            cp -rf ${PWD}/backup/ecard_solar2.ko /home/osm/driver/
            if [ $? -eq 0 ]; then
                chmod 777 /home/osm/driver/ecard_solar2.ko
                flag=0
                echo  "回滚OSM加密驱动完成"
            fi
            ;;
        *)
            log_exit "************无效输入************" $ret_fail_others
            ;;
    esac
    
    if [ $flag -eq 1 ]; then
        log_exit "************回滚加密驱动失败************" $ret_fail
    fi
}

####################### Main Function #######################
#回滚加密驱动
Rollback_driver

#回滚内核
Rollback_kernel


